'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _helperFunctions = require('./helperFunctions');

var _SVGDone = require('./SVGDone');

var _SVGDone2 = _interopRequireDefault(_SVGDone);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Step = function Step(_ref) {
	var nativeOnClick = _ref.onClick,
	    _ref$isDisabled = _ref.isDisabled,
	    isDisabled = _ref$isDisabled === undefined ? false : _ref$isDisabled,
	    isActive = _ref.isActive,
	    isComplete = _ref.isComplete,
	    renderStep = _ref.renderStep,
	    isLast = _ref.isLast;

	var getClassName = function getClassName() {
		return (0, _helperFunctions.flippyTailClass)('step__container', [isActive, 'active', 'inactive'], [isLast, 'last', 'notlast'], [isDisabled, 'disabled', 'enabled']);
	};
	var getStepProps = function getStepProps() {
		var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var className = _ref2.className,
		    style = _ref2.style,
		    _onClick = _ref2.onClick,
		    props = _objectWithoutProperties(_ref2, ['className', 'style', 'onClick']);

		return _extends({
			className: className ? getClassName() + ' ' + className : getClassName(),
			onClick: function onClick(e) {
				for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
					args[_key - 1] = arguments[_key];
				}

				e.stopPropagation();
				!isDisabled && nativeOnClick && nativeOnClick();
				!isDisabled && _onClick && _onClick.apply(undefined, [e].concat(args));
			}
		}, props);
	};

	return _react2.default.createElement(
		_react2.default.Fragment,
		null,
		renderStep({ getStepProps: getStepProps, isActive: isActive, isComplete: isComplete, isDisabled: isDisabled, isLast: isLast })
	);
};

Step.propTypes = {
	isActive: _propTypes2.default.bool.isRequired,
	isDisabled: _propTypes2.default.bool.isRequired,
	isComplete: _propTypes2.default.bool.isRequired,
	isLast: _propTypes2.default.bool.isRequired,
	renderStep: _propTypes2.default.func.isRequired
};
var enhance = (0, _recompose.compose)();

exports.default = enhance(Step);